<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryExceptionDay ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryExceptionDay extends AbstractStructArrayBase
{
    /**
     * The WSEntryExceptionDay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryExceptionDay[]
     */
    public $WSEntryExceptionDay;
    /**
     * Constructor method for ArrayOfWSEntryExceptionDay
     * @uses ArrayOfWSEntryExceptionDay::setWSEntryExceptionDay()
     * @param \StructType\WSEntryExceptionDay[] $wSEntryExceptionDay
     */
    public function __construct(array $wSEntryExceptionDay = array())
    {
        $this
            ->setWSEntryExceptionDay($wSEntryExceptionDay);
    }
    /**
     * Get WSEntryExceptionDay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryExceptionDay[]|null
     */
    public function getWSEntryExceptionDay()
    {
        return isset($this->WSEntryExceptionDay) ? $this->WSEntryExceptionDay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryExceptionDay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryExceptionDay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryExceptionDayForArrayConstraintsFromSetWSEntryExceptionDay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryExceptionDayWSEntryExceptionDayItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryExceptionDayWSEntryExceptionDayItem instanceof \StructType\WSEntryExceptionDay) {
                $invalidValues[] = is_object($arrayOfWSEntryExceptionDayWSEntryExceptionDayItem) ? get_class($arrayOfWSEntryExceptionDayWSEntryExceptionDayItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryExceptionDayWSEntryExceptionDayItem), var_export($arrayOfWSEntryExceptionDayWSEntryExceptionDayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryExceptionDay property can only contain items of type \StructType\WSEntryExceptionDay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryExceptionDay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryExceptionDay[] $wSEntryExceptionDay
     * @return \ArrayType\ArrayOfWSEntryExceptionDay
     */
    public function setWSEntryExceptionDay(array $wSEntryExceptionDay = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryExceptionDayArrayErrorMessage = self::validateWSEntryExceptionDayForArrayConstraintsFromSetWSEntryExceptionDay($wSEntryExceptionDay))) {
            throw new \InvalidArgumentException($wSEntryExceptionDayArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryExceptionDay) || (is_array($wSEntryExceptionDay) && empty($wSEntryExceptionDay))) {
            unset($this->WSEntryExceptionDay);
        } else {
            $this->WSEntryExceptionDay = $wSEntryExceptionDay;
        }
        return $this;
    }
    /**
     * Add item to WSEntryExceptionDay value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryExceptionDay $item
     * @return \ArrayType\ArrayOfWSEntryExceptionDay
     */
    public function addToWSEntryExceptionDay(\StructType\WSEntryExceptionDay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryExceptionDay) {
            throw new \InvalidArgumentException(sprintf('The WSEntryExceptionDay property can only contain items of type \StructType\WSEntryExceptionDay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryExceptionDay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryExceptionDay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryExceptionDay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryExceptionDay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryExceptionDay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryExceptionDay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryExceptionDay
     */
    public function getAttributeName()
    {
        return 'WSEntryExceptionDay';
    }
}
