<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTimestamp ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTimestamp extends AbstractStructArrayBase
{
    /**
     * The WSTimestamp
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTimestamp[]
     */
    public $WSTimestamp;
    /**
     * Constructor method for ArrayOfWSTimestamp
     * @uses ArrayOfWSTimestamp::setWSTimestamp()
     * @param \StructType\WSTimestamp[] $wSTimestamp
     */
    public function __construct(array $wSTimestamp = array())
    {
        $this
            ->setWSTimestamp($wSTimestamp);
    }
    /**
     * Get WSTimestamp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTimestamp[]|null
     */
    public function getWSTimestamp()
    {
        return isset($this->WSTimestamp) ? $this->WSTimestamp : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTimestamp method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTimestamp method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTimestampForArrayConstraintsFromSetWSTimestamp(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTimestampWSTimestampItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTimestampWSTimestampItem instanceof \StructType\WSTimestamp) {
                $invalidValues[] = is_object($arrayOfWSTimestampWSTimestampItem) ? get_class($arrayOfWSTimestampWSTimestampItem) : sprintf('%s(%s)', gettype($arrayOfWSTimestampWSTimestampItem), var_export($arrayOfWSTimestampWSTimestampItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTimestamp property can only contain items of type \StructType\WSTimestamp, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTimestamp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTimestamp[] $wSTimestamp
     * @return \ArrayType\ArrayOfWSTimestamp
     */
    public function setWSTimestamp(array $wSTimestamp = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTimestampArrayErrorMessage = self::validateWSTimestampForArrayConstraintsFromSetWSTimestamp($wSTimestamp))) {
            throw new \InvalidArgumentException($wSTimestampArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTimestamp) || (is_array($wSTimestamp) && empty($wSTimestamp))) {
            unset($this->WSTimestamp);
        } else {
            $this->WSTimestamp = $wSTimestamp;
        }
        return $this;
    }
    /**
     * Add item to WSTimestamp value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTimestamp $item
     * @return \ArrayType\ArrayOfWSTimestamp
     */
    public function addToWSTimestamp(\StructType\WSTimestamp $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTimestamp) {
            throw new \InvalidArgumentException(sprintf('The WSTimestamp property can only contain items of type \StructType\WSTimestamp, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTimestamp[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTimestamp|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTimestamp|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTimestamp|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTimestamp|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTimestamp|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTimestamp
     */
    public function getAttributeName()
    {
        return 'WSTimestamp';
    }
}
