<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WSTripList StructType
 * @subpackage Structs
 */
class WSTripList extends AbstractStructBase
{
    /**
     * The additionalValues
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $additionalValues;
    /**
     * The customers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSCustomer
     */
    public $customers;
    /**
     * The extensions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSExtension
     */
    public $extensions;
    /**
     * The persons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSPerson
     */
    public $persons;
    /**
     * The trips
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSTrip2
     */
    public $trips;
    /**
     * The vehicles
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSVehicle
     */
    public $vehicles;
    /**
     * Constructor method for WSTripList
     * @uses WSTripList::setAdditionalValues()
     * @uses WSTripList::setCustomers()
     * @uses WSTripList::setExtensions()
     * @uses WSTripList::setPersons()
     * @uses WSTripList::setTrips()
     * @uses WSTripList::setVehicles()
     * @param \ArrayType\ArrayOfWSKeyValue $additionalValues
     * @param \ArrayType\ArrayOfWSCustomer $customers
     * @param \ArrayType\ArrayOfWSExtension $extensions
     * @param \ArrayType\ArrayOfWSPerson $persons
     * @param \ArrayType\ArrayOfWSTrip2 $trips
     * @param \ArrayType\ArrayOfWSVehicle $vehicles
     */
    public function __construct(\ArrayType\ArrayOfWSKeyValue $additionalValues = null, \ArrayType\ArrayOfWSCustomer $customers = null, \ArrayType\ArrayOfWSExtension $extensions = null, \ArrayType\ArrayOfWSPerson $persons = null, \ArrayType\ArrayOfWSTrip2 $trips = null, \ArrayType\ArrayOfWSVehicle $vehicles = null)
    {
        $this
            ->setAdditionalValues($additionalValues)
            ->setCustomers($customers)
            ->setExtensions($extensions)
            ->setPersons($persons)
            ->setTrips($trips)
            ->setVehicles($vehicles);
    }
    /**
     * Get additionalValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getAdditionalValues()
    {
        return isset($this->additionalValues) ? $this->additionalValues : null;
    }
    /**
     * Set additionalValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSKeyValue $additionalValues
     * @return \StructType\WSTripList
     */
    public function setAdditionalValues(\ArrayType\ArrayOfWSKeyValue $additionalValues = null)
    {
        if (is_null($additionalValues) || (is_array($additionalValues) && empty($additionalValues))) {
            unset($this->additionalValues);
        } else {
            $this->additionalValues = $additionalValues;
        }
        return $this;
    }
    /**
     * Get customers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSCustomer|null
     */
    public function getCustomers()
    {
        return isset($this->customers) ? $this->customers : null;
    }
    /**
     * Set customers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSCustomer $customers
     * @return \StructType\WSTripList
     */
    public function setCustomers(\ArrayType\ArrayOfWSCustomer $customers = null)
    {
        if (is_null($customers) || (is_array($customers) && empty($customers))) {
            unset($this->customers);
        } else {
            $this->customers = $customers;
        }
        return $this;
    }
    /**
     * Get extensions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSExtension|null
     */
    public function getExtensions()
    {
        return isset($this->extensions) ? $this->extensions : null;
    }
    /**
     * Set extensions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSExtension $extensions
     * @return \StructType\WSTripList
     */
    public function setExtensions(\ArrayType\ArrayOfWSExtension $extensions = null)
    {
        if (is_null($extensions) || (is_array($extensions) && empty($extensions))) {
            unset($this->extensions);
        } else {
            $this->extensions = $extensions;
        }
        return $this;
    }
    /**
     * Get persons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSPerson|null
     */
    public function getPersons()
    {
        return isset($this->persons) ? $this->persons : null;
    }
    /**
     * Set persons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSPerson $persons
     * @return \StructType\WSTripList
     */
    public function setPersons(\ArrayType\ArrayOfWSPerson $persons = null)
    {
        if (is_null($persons) || (is_array($persons) && empty($persons))) {
            unset($this->persons);
        } else {
            $this->persons = $persons;
        }
        return $this;
    }
    /**
     * Get trips value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSTrip2|null
     */
    public function getTrips()
    {
        return isset($this->trips) ? $this->trips : null;
    }
    /**
     * Set trips value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSTrip2 $trips
     * @return \StructType\WSTripList
     */
    public function setTrips(\ArrayType\ArrayOfWSTrip2 $trips = null)
    {
        if (is_null($trips) || (is_array($trips) && empty($trips))) {
            unset($this->trips);
        } else {
            $this->trips = $trips;
        }
        return $this;
    }
    /**
     * Get vehicles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSVehicle|null
     */
    public function getVehicles()
    {
        return isset($this->vehicles) ? $this->vehicles : null;
    }
    /**
     * Set vehicles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSVehicle $vehicles
     * @return \StructType\WSTripList
     */
    public function setVehicles(\ArrayType\ArrayOfWSVehicle $vehicles = null)
    {
        if (is_null($vehicles) || (is_array($vehicles) && empty($vehicles))) {
            unset($this->vehicles);
        } else {
            $this->vehicles = $vehicles;
        }
        return $this;
    }
}
